require File.expand_path('../test_helper', __FILE__)

class S3Test < Test::Unit::TestCase
  context "The S3restful::S3 module" do
    
    should "allow to set global SSL options" do
      assert S3restful::S3.respond_to?(:ssl_options)
      assert S3restful::S3.respond_to?(:ssl_options=)
    end
    
    should "set and get verify_peer" do
      S3restful::S3.ssl_options[:verify_peer] = true
      assert S3restful::S3.ssl_options[:verify_peer]
      S3restful::S3.ssl_options[:verify_peer] = false
      assert !S3restful::S3.ssl_options[:verify_peer]
    end
    
    should "set and get cert_chain_file" do
      S3restful::S3.ssl_options[:cert_chain_file] = '/etc/cacert'
      assert_equal '/etc/cacert', S3restful::S3.ssl_options[:cert_chain_file]
      S3restful::S3.ssl_options[:cert_chain_file] = nil
      assert_nil S3restful::S3.ssl_options[:cert_chain_file]
    end
    
    should "default to no certificate file and no verification" do
      S3restful::S3.instance_variable_set("@_ssl_options", nil)
      assert !S3restful::S3.ssl_options[:verify_peer]
      assert_nil S3restful::S3.ssl_options[:cert_chain_file]
    end
    
  end
end
